%%%%% Supp = [Rsupport Csupport Hsupport] %%%%%
function [R3D_best Min_errorF] = HIO3D(F3D,Supp,HIO_iteration,showimage,perfect)

[Rsize,Csize,Hsize] = size(F3D);

Rcenter = (Rsize+1)/2;
Ccenter = (Csize+1)/2;
Hcenter = (Hsize+1)/2;

Rsupport = Supp(1);
Csupport = Supp(2);
Hsupport = Supp(3);
half_Rsupport = (Rsupport-1)/2;
half_Csupport = (Csupport-1)/2;
half_Hsupport = (Hsupport-1)/2;

stopper = find(F3D==-1);

iteration_times = HIO_iteration;

Rtemp = zeros(Rsize,Csize,Hsize);
load Glass3DLog_14cube.mat;
MMM = zeros(15,15,15);
MMM(1:14,1:14,1:14) = GGG;
Rtot = zeros(Rsize,Csize,Hsize);
Rtot(Rcenter-half_Rsupport:Rcenter+half_Rsupport,Ccenter-half_Csupport:Ccenter+half_Csupport,Hcenter-half_Hsupport:Hcenter+half_Hsupport) = MMM;

load Tsupp_15cube.mat
Rtemp(Rcenter-half_Rsupport:Rcenter+half_Rsupport,Ccenter-half_Csupport:Ccenter+half_Csupport,Hcenter-half_Hsupport:Hcenter+half_Hsupport) = TTT;
loose_support = find(Rtemp==1);

rand('state',sum(100*clock));
phase_angle = rand(Rsize,Csize,Hsize); 
if perfect==1
    phase_angle = angle(fftshift(fftn(Rtot)));
end
k_space = F3D.*exp(i*phase_angle);

clear Rtemp Rtot;

buffer_r_space = real(ifftn(ifftshift(k_space)));
    
Min_errorF = 100;  
para = 0.9;
if showimage==1    
    figure(9999)
end

for iteration = 1:iteration_times
    if iteration<=HIO_iteration        
        r_space = real(ifftn(ifftshift(k_space)));        
        sample = r_space(loose_support);       
        r_space = buffer_r_space - para*r_space;      
        buffer_sample = buffer_r_space(loose_support);
        sample(sample<0) = buffer_sample(sample<0) - para*sample(sample<0); 
        r_space(loose_support) = sample;
        buffer_r_space = r_space;
        k_space = fftshift(fftn(r_space));       
        phase_angle = angle(k_space);
          
        stopper_k_space = k_space(stopper);    
        k_space = F3D.*exp(i*phase_angle);   
        k_space(stopper) = stopper_k_space;   
        
        if showimage==1
            Rinside = r_space(Rcenter-half_Rsupport:Rcenter+half_Rsupport,Ccenter-half_Csupport:Ccenter+half_Csupport,Hcenter-half_Hsupport:Hcenter+half_Hsupport);            
            subplot(231),imagesc(reshape(Rinside(:,:,round(Rsupport/2)-1),[Csupport Hsupport])); axis image; title(iteration)
            subplot(232),imagesc(reshape(Rinside(:,:,round(Rsupport/2)),[Csupport Hsupport])); axis image; 
            subplot(233),imagesc(reshape(Rinside(:,:,round(Rsupport/2)+1),[Csupport Hsupport])); axis image; title(Min_errorF)
            subplot(234),imagesc(reshape(MMM(:,:,round(Rsupport/2)-1),[Csupport Hsupport])); axis image; 
            subplot(235),imagesc(reshape(MMM(:,:,round(Rsupport/2)),[Csupport Hsupport])); axis image; 
            subplot(236),imagesc(reshape(MMM(:,:,round(Rsupport/2)+1),[Csupport Hsupport])); axis image; 
            drawnow
        end
                   
        %%%%% Calculate errorF    
        if rem(iteration,10)==0
            Ktemp = zeros(Rsize,Csize,Hsize);
            Ktemp(loose_support) = abs(sample);
            Ktemp = abs(fftshift(fftn(Ktemp)));
            errorF = sum(sum(abs(Ktemp(F3D~=-1)-F3D(F3D~=-1)))) / sum(sum(F3D(F3D~=-1)));
            if errorF<Min_errorF
                Min_errorF = errorF;
                R3D_best = (r_space(Rcenter-half_Rsupport:Rcenter+half_Rsupport,Ccenter-half_Csupport:Ccenter+half_Csupport,Hcenter-half_Hsupport:Hcenter+half_Hsupport));
            end
        end
        %%%%%
    end
    %%%%%
end 
